program VeremProba;
(*
  Feladat:
    A verem folytonos brzols melletti implementlsa.
  Mdszer:
  * Albb lthat a ksz verem unit teljes interface-rsze.
  * Mivel ugyanez nem ll rendelkezsre forrs nyelvi szinten,
    ezrt a rutinokat sorravve, elszr ebbe a forrs fjlba,
    az eredetileg meglv eljrsok el, berjuk a mi sajt vltozatunkat.
  * Tudjuk, hogy nvtkzs esetn a fprogramba lv nv "gazdja"
    (pl. egy eljrs) "elnyt lvez" (eljrs esetn az lesz meghvva),
    gy mindig ellenrizhet, hogy az j eljrssal ugyangy fut-e le, mint
    az eredetivel.
*)
  Uses {Newdelay,}Crt,VeremUnF{TElem};

(*
  Modul TVerem(Type TElem):
  Folytonos brzols verem.

Interface

  Type
    TElem = String;{modulparamter}
  Const
    MaxMelyseg=100;
  Type
    TIndex=0..MaxMelyseg;
    TVerem = Record
               tomb :Array [1..MaxMelyseg] of TElem;
               teto :TIndex;
               hiba :Boolean;
             End;

  Procedure Ures(Var v:TVerem);
  Procedure Verembe(Var v:TVerem; e:TElem);
  Procedure Verembol(Var v:TVerem; Var e:TElem);
  Function  UresE(Const v:TVerem):Boolean;
  Function  TeliE(Const v:TVerem):Boolean;
  Function  HibasE(Var v:TVerem):Boolean;
  Function  Melyseg(Var v:TVerem):Word;
*)


  {$i AltRutin.inc}
  {$i RandNev.inc}

(*
  ------------------ ide fejlesztendk a sajt rutinok ---------------------

  Pl. ha az albbi rossz fggvnymegvalstst kiszedi a kommentek kzl,
  akkor azt fogja tapasztalni, hogy a mlysget llandan 1-nek fogjuk
  rzkelni... pedig?

  Function Melyseg(Var v:TVerem):Word;
  Begin
    Melyseg:=1
  End;
*)

  Procedure Proba_1;
    Var
      v:TVerem;
      e:TElem;
  Begin
    UjLap('Verem -- prba (1)',0);
    Ures(v);
    Writeln('Verem-llapot');
    Writeln('  hiba-llapot:',HibasE(v));
    Writeln('       mlysg:',Melyseg(v),CrLf);
    Writeln('  res verembl elemkivtel:');
    Verembol(v,e);
    Writeln('  a kivett elem (NemDef!): "',e,'"=teljesen vletlenszer rtk!');
    Writeln('             hiba-llapot:',HibasE(v));
  End;{Proba_1}

  Procedure Proba_2;
    Var
      v:TVerem;
      e:TElem;
      i:TIndex;
  Begin
    UjLap('Verem -- prba (2)',-1);
    Ures(v);
    Writeln('     Verembe(v): e(mlysg)         ---->   Verembl(v): e(mlysg)');
    For i:=1 to 10 do
    Begin
      e:=RandomNev;
      GotoXY(5,i+2); Writeln(e:20,'(',Melyseg(v),')');
      Verembe(v,e);
    End;
    BillreVar;

    HighVideo;
    For i:=1 to 10 do
    Begin
      Verembol(v,e);
      GotoXY(45,i+2); Writeln(e:20,'(',Melyseg(v),')');
    End;
    NormVideo;
  End;{Proba_2}


  Procedure Proba_3;
    Var
      v,w:TVerem;
      e:TElem;
      i:TIndex;
  Begin
    UjLap('Verem -- prba (3)',-1);
    Writeln('     v.be: ve(mly.)     --->  v.bl:e(mly.)->w.be  --->  w.bl: e(mly.)');
    Ures(v); Ures(w);
    HighVideo;
    For i:=1 to 10 do
    Begin
      e:=RandomNev;
      GotoXY(1,i+2); Writeln(e:20,'(',Melyseg(v),')');
      Verembe(v,e);
    End;
    NormVideo;
    BillreVar;

    For i:=1 to 10 do
    Begin
      Verembol(v,e); Verembe(w,e);
      GotoXY(27,i+2); Writeln(e:20,'(',Melyseg(v),')');
    End;
    BillreVar;

    HighVideo;
    For i:=1 to 10 do
    Begin
      Verembol(w,e);
      GotoXY(55,i+2); Writeln(e:20,'(',Melyseg(w),')');
    End;
    NormVideo;
    BillreVar;
  End;{Proba_3}

  Procedure Proba_4;
    Var
      v,w:TVerem;
      e:TElem;
      i:TIndex;
  Begin
    UjLap('Verem -- prba (4)',-1);
    {... a telesg-kezels ellenrzse...}
    Writeln('... a telesg-kezels ellenrzse...');
    BillreVar;
  End;{Proba_4}

Begin
  Proba_1;
  Proba_2;
  Proba_3;
  Proba_4;
End.
